#include "com_googlecode_mso_libmso_LibMso.h"
#include <hd.h>
#include <jni.h>
#include <stdlib.h>
JNIEXPORT jobject JNICALL Java_com_googlecode_mso_libmso_LibMso_listPrinters
(
		JNIEnv *env,
		jclass cls
)
{
	hd_data_t *hd_data;
	hd_t *hd;

	jmethodID listConst, addToList, printerConst;
	jclass listCls, printerCls;
	jobject list;

	hd_data = calloc(1, sizeof *hd_data);
	hd = hd_list(hd_data, hw_printer, 1, NULL);
	hd_t *head = hd;

	listCls = (*env)->FindClass(env, "java/util/ArrayList");
	if(listCls == NULL) {
		printf("FindClass failed for ArrayList");
		return NULL;
	}
	listConst = (*env)->GetMethodID(env, listCls, "<init>", "()V");
	if(listConst == NULL) {
		printf("GetMethodID failed for ArrayList constructor");
		return NULL;
	}
	list = (*env)->NewObject(env, listCls, listConst);
	if(list == NULL) {
		printf("Error constructing ArrayList");
		return NULL;
	}

	addToList = (*env)->GetStaticMethodID(env, cls, "addToList", "(Ljava/util/List;Lcom/googlecode/mso/libmso/Printer;)V");
	if(addToList == NULL) {
		printf("GetMethodID failed for addToList\n");
		return NULL;
	}
	printerCls = (*env)->FindClass(env, "com/googlecode/mso/libmso/Printer");
	if(printerCls == NULL) {
		printf("FindClass failed for Printer\n");
		return NULL;
	}
	printerConst = (*env)->GetMethodID(env, printerCls,"<init>", "()V");
	if(printerConst == NULL) {
		printf("GetMethodID failed for Printer constructor\n");
		return NULL;
	}

	while (hd != NULL) {
		jobject printer;
		jfieldID fieldID;

		printer = (*env)->NewObject(env, printerCls, printerConst);
		if(printer == NULL) {
			printf("Error constructing Printer");
			return NULL;
		}

		fieldID = (*env)->GetFieldID(env, printerCls,"vendor", "Ljava/lang/String;");
		if(fieldID == NULL) {
			printf("GetFieldID failed for vendor");
			return NULL;
		}
		(*env)->SetObjectField(env, printer, fieldID, (*env)->NewStringUTF(env, hd->vendor.name));
		if ((*env)->ExceptionOccurred(env)) {
			printf("SetObjectField failed for vendor");
			return NULL;
		}

		fieldID= (*env)->GetFieldID(env, printerCls,"name", "Ljava/lang/String;");
		if(fieldID == NULL) {
			printf("GetFieldID failed for name");
			return NULL;
		}
		(*env)->SetObjectField(env, printer, fieldID, (*env)->NewStringUTF(env, hd->device.name));
		if ((*env)->ExceptionOccurred(env)) {
			printf("SetObjectField failed for name");
			return NULL;
		}

		fieldID= (*env)->GetFieldID(env, printerCls,"serial", "Ljava/lang/String;");
		if(fieldID == NULL) {
			printf("GetFieldID failed for serial");
			return NULL;
		}
		(*env)->SetObjectField(env, printer, fieldID, (*env)->NewStringUTF(env, hd->serial));
		if ((*env)->ExceptionOccurred(env)) {
			printf("SetObjectField failed for serial");
			return NULL;
		}

		fieldID= (*env)->GetFieldID(env, printerCls,"driver", "Ljava/lang/String;");
		if(fieldID == NULL) {
			printf("GetFieldID failed for driver");
			return NULL;
		}
		(*env)->SetObjectField(env, printer, fieldID, (*env)->NewStringUTF(env, hd->driver));
		if ((*env)->ExceptionOccurred(env)) {
			printf("SetObjectField failed for driver");
			return NULL;
		}

		fieldID= (*env)->GetFieldID(env, printerCls,"portType", "Ljava/lang/String;");
		if(fieldID == NULL) {
			printf("GetFieldID failed for portType");
			return NULL;
		}
		(*env)->SetObjectField(env, printer, fieldID, (*env)->NewStringUTF(env, hd->bus.name));
		if ((*env)->ExceptionOccurred(env)) {
			printf("SetObjectField failed for portType");
			return NULL;
		}

		fieldID= (*env)->GetFieldID(env, printerCls,"deviceFile", "Ljava/lang/String;");
		if(fieldID == NULL) {
			printf("GetFieldID failed for deviceFile");
			return NULL;
		}
		(*env)->SetObjectField(env, printer, fieldID, (*env)->NewStringUTF(env, hd->unix_dev_name));
		if ((*env)->ExceptionOccurred(env)) {
			printf("SetObjectField failed for deviceFile");
			return NULL;
		}

		(*env)->CallStaticVoidMethod(env, cls, addToList, list, printer);
		if ((*env)->ExceptionOccurred(env)) {
			printf("CallStaticVoidMethod failed for addToList");
			return NULL;
		}

		hd = hd->next;

	}
	if (head != NULL)
		hd_free_hd_list(head);
	if (hd_data != NULL) {
		hd_free_hd_data(hd_data);
		free(hd_data);
	}
	return list;
}
