package com.googlecode.mso.libmso;
import java.util.List;

import com.googlecode.mso.jinklevel.Cartridge;
import com.googlecode.mso.jinklevel.InkLevelException;
import com.googlecode.mso.jinklevel.JInkLevel;
import com.googlecode.mso.jinklevel.PortType;

public class Printer {
	private String vendor,name,serial,driver,deviceFile,portType;

	/**
	 * Returns the model of the printer
	 */
	public String getModel() {
		return vendor+" "+name;
	}

	/**
	 * Returns the serial number of the printer
	 */
	public String getSerial() {
		return serial;
	}

	/**
	 * Returns the driver (i.e kernel module) of the printer
	 */
	public String getDriver() {
		return driver;
	}

	/**
	 * Returns the unix device filename of the printer
	 */
	public String getDeviceFile() {
		return deviceFile;
	}

	/**
	 * Query cartridges found in this printer.
	 * @throws InkLevelException
	 */
	public List<Cartridge> getCartridges() throws InkLevelException {
		return JInkLevel.listCartridges(getPortType(), deviceFile, 0);
	}

	private PortType getPortType() {
		if("USB".equals(portType)) {
			return PortType.CUSTOM_USB;
		} else {
			return PortType.CUSTOM_PARPORT;
		}
	}
}
